
        MODULE  ?cstartup

        ;; Forward declaration of sections.
        SECTION CSTACK:DATA:NOROOT(3)

        SECTION .intvec:CODE:NOROOT(2)

        EXTERN  __iar_program_start
        PUBLIC  __vector_table

        DATA
        
__vector_table
        DCD     sfe(CSTACK)
        DCD     Reset_Handler             ; Reset Handler
        DCD     NMI_Handler               ; NMI Handler
        DCD     HardFault_Handler         ; Hard Fault Handler
        DCD     0                         ; Reserved
        DCD     0                         ; Reserved
        DCD     0                         ; Reserved
        DCD     0                         ; Reserved
        DCD     0                         ; Reserved
        DCD     0                         ; Reserved
        DCD     0                         ; Reserved
        DCD     SVC_Handler               ; SVCall Handler
        DCD     0                         ; Reserved
        DCD     0                         ; Reserved
        DCD     PendSV_Handler            ; PendSV Handler
        DCD     SysTick_Handler           ; SysTick Handler

        ; External Interrupts
        DCD     WDT_IRQHandler            	; 0:  IWDT &  WWDT 
        DCD     SVD_IRQHandler            	; 1:  SVD 	
        DCD     RTC_IRQHandler            	; 2:  RTC 	
        DCD     FLASH_IRQHandler	      	; 3:  FLASH	
        DCD     FDET_IRQHandler	          	; 4:  FDET	
        DCD     ADC_IRQHandler            	; 5:  ADC	
        DCD     RAMP_IRQHandler           	; 6:  RAMP
        DCD     SPI0_IRQHandler           	; 7:  SPI0 	
        DCD     SPI1_IRQHandler           	; 8:  SPI1
        DCD     DAC_IRQHandler           	; 9:  DAC	
        DCD     UART0_IRQHandler           	; 10:  UART0	
        DCD     UART1_IRQHandler           	; 11:  UART1		
        DCD     UART2_IRQHandler           	; 12:  UART2	
        DCD     UART3_IRQHandler           	; 13:  UART3	
        DCD     UART4_IRQHandler           	; 14:  UART4		
        DCD     FSCAN_IRQHandler		  	; 15:  FSCAN	
        DCD     LPUARTx_IRQHandler	      	; 16:  LPUART	
        DCD     I2CSMBx_IRQHandler       	; 17:  I2Cx	
        DCD     CLM_PGL_IRQHandler          ; 18:  CLM_PGL	
        DCD     AES_IRQHandler         	  	; 19:  AES	
        DCD     LPTIM16_IRQHandler          ; 20:  LPTIM16	
        DCD     DMA_IRQHandler            	; 21:  DMA	
        DCD     WKUPx_IRQHandler          	; 22:  WKUP	
        DCD     SENTx_IRQHandler          	; 23:  SENT	
        DCD     BSTIM16_IRQHandler          ; 24:  BSTIM16
        DCD     COMPx_IRQHandler          	; 25:  COMPx
        DCD     GPTIM0_IRQHandler          	; 26:  GPTIM0	
        DCD     GPTIM1_IRQHandler          	; 27:  GPTIM1	
        DCD     ATIM_IRQHandler           	; 28:  ATIM	
        DCD     TAU0_IRQHandler          	; 29:  TAU0	
        DCD     GPIO_IRQHandler           	; 30:  GPIO
        DCD     LED_LCD_IRQHandler        	; 31:  LED_LCD
__Vectors_End
                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Default interrupt handlers.
;;
        THUMB

        PUBWEAK Reset_Handler
        SECTION .text:CODE:NOROOT:REORDER(2)
Reset_Handler
        IMPORT  SystemInit
        LDR     R0, =SystemInit
        BLX     R0		
        LDR     R0, =__iar_program_start
        ;LDR     R0, =__main
        BX      R0
        
        PUBWEAK NMI_Handler
        SECTION .text:CODE:NOROOT:REORDER(1)
NMI_Handler
        B NMI_Handler
        
        
        PUBWEAK HardFault_Handler
        SECTION .text:CODE:NOROOT:REORDER(1)
HardFault_Handler
        B HardFault_Handler
       
        
        PUBWEAK SVC_Handler
        SECTION .text:CODE:NOROOT:REORDER(1)
SVC_Handler
        B SVC_Handler
        
        
        PUBWEAK PendSV_Handler
        SECTION .text:CODE:NOROOT:REORDER(1)
PendSV_Handler  
        B PendSV_Handler
        
        
        PUBWEAK SysTick_Handler
        SECTION .text:CODE:NOROOT:REORDER(1)
SysTick_Handler
        B SysTick_Handler
        
        
        PUBWEAK WDT_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
WDT_IRQHandler
        B WDT_IRQHandler
        
                
        PUBWEAK SVD_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
SVD_IRQHandler
        B SVD_IRQHandler
        
                
        PUBWEAK RTC_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
RTC_IRQHandler
        B RTC_IRQHandler
        
                
        PUBWEAK FLASH_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
FLASH_IRQHandler
        B FLASH_IRQHandler
        
                
        PUBWEAK FDET_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
FDET_IRQHandler
        B FDET_IRQHandler
        
                
        PUBWEAK ADC_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
ADC_IRQHandler
        B ADC_IRQHandler
  
        PUBWEAK RAMP_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
RAMP_IRQHandler
        B RAMP_IRQHandler
       
       
        PUBWEAK SPI0_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
SPI0_IRQHandler
        B SPI0_IRQHandler
        

        PUBWEAK SPI1_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
SPI1_IRQHandler
        B SPI1_IRQHandler
        
                                
        PUBWEAK DAC_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
DAC_IRQHandler
        B DAC_IRQHandler
        
                
        PUBWEAK UART0_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
UART0_IRQHandler
        B UART0_IRQHandler
        
                
        PUBWEAK UART1_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
UART1_IRQHandler
        B UART1_IRQHandler
        
                
        PUBWEAK UART2_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
UART2_IRQHandler
        B UART2_IRQHandler
        
                
        PUBWEAK UART3_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
UART3_IRQHandler
        B UART3_IRQHandler
        
                
        PUBWEAK UART4_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
UART4_IRQHandler
        B UART4_IRQHandler
        
                 
        PUBWEAK FSCAN_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
FSCAN_IRQHandler
        B FSCAN_IRQHandler
        
                 
        PUBWEAK LPUARTx_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
LPUARTx_IRQHandler
        B LPUARTx_IRQHandler
        
                
        PUBWEAK I2CSMBx_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
I2CSMBx_IRQHandler
        B I2CSMBx_IRQHandler
        
        PUBWEAK CLM_PGL_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
CLM_PGL_IRQHandler
        B CLM_PGL_IRQHandler
        
                
        PUBWEAK AES_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
AES_IRQHandler
        B AES_IRQHandler
                  
                  
        PUBWEAK LPTIM16_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
LPTIM16_IRQHandler
        B LPTIM16_IRQHandler
                
                
        PUBWEAK DMA_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
DMA_IRQHandler
        B DMA_IRQHandler
        
        
        PUBWEAK WKUPx_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
WKUPx_IRQHandler
        B WKUPx_IRQHandler
   
   
        PUBWEAK SENTx_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
SENTx_IRQHandler
        B SENTx_IRQHandler


        PUBWEAK BSTIM16_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
BSTIM16_IRQHandler
        B BSTIM16_IRQHandler 
      
      
        PUBWEAK COMPx_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
COMPx_IRQHandler
        B COMPx_IRQHandler



        PUBWEAK GPTIM0_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
GPTIM0_IRQHandler
        B GPTIM0_IRQHandler
        
                
        PUBWEAK GPTIM1_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
GPTIM1_IRQHandler
        B GPTIM1_IRQHandler
               
        
        
        PUBWEAK ATIM_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
ATIM_IRQHandler
        B ATIM_IRQHandler
         
         
        PUBWEAK TAU0_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
TAU0_IRQHandler
        B TAU0_IRQHandler
        
        
         PUBWEAK GPIO_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
GPIO_IRQHandler
        B GPIO_IRQHandler
        
        
         PUBWEAK LED_LCD_IRQHandler
        SECTION .text:CODE:NOROOT:REORDER(1)
LED_LCD_IRQHandler
        B LED_LCD_IRQHandler
        END